package uoc.ei.exemples.modul1;

/**
 * Interfcie que defineix les operacions d'un conjunt.
 *
 * Els conjunts sn estructures que emmagatzemen elements no repetits. La
 * classe dels objectes ha de disposar d'una operaci d'igualtat.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public interface Conjunt {

	/**
    * Afegeix un element al conjunt. Si aquest ja hi s, no fa res.
    * @param elem L'element que es vol afegir al conjunt
    */
   public void afegir(Object elem);

   /**
    * Comprova si hi ha un element.
    * @param elem  element de referncia
    * @return  cert o fals, segons si el conjunt cont o no l'element.
    */
   public boolean hiEs(Object elem);

   /**
    * Esborra un element del conjunt. Si l'element no hi s, no fa res.
    * @param elem  element a esborrar.
    * @return L'element esborrat; o null, si no hi era
    */
   public Object esborrar(Object elem);


   /**
    * @return true si el conjunt est buit i false en cas contrari.
    */
   public boolean estaBuit();

}
