package uoc.ei.exemples.modul1;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class NatbImpl implements Nat {

	/** Aquesta classe representa el natural mitjanant
	 * una taula de booleans. La representaci d'un natural
	 * N es correspon amb una taula on les N primeres
	 * posicions de la taula tenen el valor true i la posici
	 * N+1 t el valor false.
	 */
	private boolean[] nat;

	/** Crea una instncia de natural amb valor 0.
	 * @post nat!=null && nat[0]==false
	 */
	public NatbImpl() {
		nat=new boolean[10];
	}

	public void succ() {
		int i=cercarDarreraPosicio();
		marcarPosicio(i+1,true);
	}

	public void pred() {
		int i=cercarDarreraPosicio();
		marcarPosicio(i,false);
	}

	public void sumarQuantitat(Nat y) {
		int i=cercarDarreraPosicio();
		int j=y.consultar();
		while (j-->0)
			marcarPosicio(++i,true);
	}

	/**
	 * @pre true
	 * @post nat == inicial(nat) &&
	 * 		$pertot(nat,0,$return-1,index,nat[index] == true) &&
	 * 		(nat.length<$return || nat[$return]==false)
	 */
	public int consultar() {
		return cercarDarreraPosicio()+1;
	}

	/** Retorna una representaci en format text del
	 * natural.
	 * @pre true
	 * @post nat==inicial(nat)
	 */
	public String toString() {
		return Integer.toString(consultar());
	}


	/**
	 * @pre true
	 * @post nat == inicial(nat) &&
	 * 		$pertot(nat,0,$return,i,nat[i]) &&
	 * 		(nat.length<$return+1 || nat[$return+1]==false)
	 */
	private int cercarDarreraPosicio() {
		int i=0;
		while (i<nat.length && nat[i])
			i++;
		return i-1;
	}

	/**
	 * @pre true
	 * @post $pertot(nat,j,j==i || nat[j] == $inicial(nat[j])) && nat[i]==valor
	 */
	private void marcarPosicio(int i,boolean valor) {
		if (i>=nat.length)
			duplicarVector();
		nat[i]=valor;
	}

	/**
	 * @pre true
	 * @post $pertot(nat,i,
	 * 					i<$inicial(nat.length) && nat[i]==$inicial(nat[i]) ||
	 * 					i>=$inicial(nat.length) && !nat[i])
	 */
	private void duplicarVector() {
		boolean[] nou=new boolean[nat.length*2];
		for(int i=0;i<nat.length;i++)
			nou[i]=nat[i];
		nat=nou;
	}

}
