package uoc.ei.exemples.modul1;

import java.io.IOException;
import java.io.InputStream;

/** Prova el TAD conjunt, creant un conjunt i introdunt-hi
 * elements que l'usuari va donant per l'entrada estndar.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class ProvaConjunt {


    protected static String readLine(String str,InputStream in) throws IOException {
        if (str!=null) System.out.println(str);
        StringBuffer buffer=new StringBuffer();
        int c=in.read();
        while (c=='\n' || c=='\r') c=in.read();
        while (c!='\n' && c!='\r') {
            buffer.append((char)c);
            c=in.read();
        }
        return buffer.toString();
    }


	public static void main(String[] args) {
		System.out.println("Introdueix nombres naturals a afegir al conjunt");
		boolean sortir=false;
		ConjuntAfitat cjt=new ConjuntVectorImpl(10);
		while (!sortir) {
			try {
				String elem=readLine("Introdueix un nombre (o \"fi\" per acabar): ",System.in);
				sortir=elem.equalsIgnoreCase("fi");
				cjt.afegir(new Integer(Integer.parseInt(elem)));
				if (cjt.estaPle()) {
					System.out.println("El conjunt est ple. No s'hi poden afegir ms elements.");
					sortir=true;
				}
			} catch (NumberFormatException e) {
				System.out.println("El text introdut no s un nombre, torna-ho a provar.");
			} catch (IOException e) {
				System.out.println("Problema amb l'entrada, avortant el programa");
				sortir=true;
			}
		}
		System.out.println("El conjunt resultant s: "+cjt);
	}

}
