package uoc.ei.exemples.modul1.defensiu;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface NatDefensiu {

	/** Aquest mtode incrementa el valor del natural.
	 * @pre true
	 * @post consultar() == $inicial(consultar())+1
	 */
	void succ();

	/** Aquest mtode decrementa el valor del natural.
	 * @pre consultar()>0
	 * @post consultar() == $inicial(consultar())-1
	 */
	void pred() throws ExcepcioNat;

	/** Aquest mtode suma un natural a l'objecte.
	 * @pre true
	 * @post consultar() == $inicial(consultar())+y.consultar()
	 * @param y El natural a sumar.
	 */
	void sumarQuantitat(NatDefensiu y);

	/** Mtode consultor que retorna el valor del
	 * natural com un enter.
	 * @return el valor de l'objecte.
	 */
	int consultar();
}
