package uoc.ei.exemples.modul1.generics;

import java.io.IOException;
import uoc.ei.tads.Utilitats;

/** Prova el TAD conjunt, creant un conjunt i introdunt-hi
 * elements que l'usuari va donant per l'entrada estndar.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class ProvaConjunt {


	public static void main(String[] args) {
		System.out.println("Introdueix nombres naturals a afegir al conjunt");
		boolean sortir=false;
		ConjuntAfitat<Integer> cjt=new ConjuntVectorImpl<Integer>(10);
		while (!sortir) {
			try {
				String elem=Utilitats.llegirString("Introdueix un nombre (o \"fi\" per acabar): ",System.in);
				sortir=elem.equalsIgnoreCase("fi");
				if (!sortir)
					cjt.afegir(Integer.parseInt(elem));
				if (cjt.estaPle()) {
					System.out.println("El conjunt est ple. No s'hi poden afegir ms elements.");
					sortir=true;
				}
			} catch (NumberFormatException e) {
				System.out.println("El text introdut no s un nombre, torna-ho a provar.");
			} catch (IOException e) {
				System.out.println("Problema amb l'entrada, avortant el programa");
				sortir=true;
			}
		}
		System.out.println("El conjunt resultant s: "+cjt);
	}

}
