package uoc.ei.exemples.modul2;

import java.util.*;
import uoc.ei.exemples.modul1.generics.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Bingo {


	private Jugador[] jugadors;
	private int numeroDeJugadors;
	private int numeroDeBoles;
	private int midaCartro;

	private Conjunt<Integer> bolesCantades;

	private Random generadorNumerosCartro;


	public Bingo(int numeroDeJugadorsMaxim,int numeroDeBoles,int midaCartro) {
		jugadors=new Jugador[numeroDeJugadorsMaxim];
		numeroDeJugadors=0;
		this.numeroDeBoles=numeroDeBoles;
		this.midaCartro=midaCartro;
		generadorNumerosCartro=new Random();
	}


	public void nouJugador(String nom) {
		Jugador jugador=new Jugador(nom);
		jugadors[numeroDeJugadors]=jugador;
		numeroDeJugadors++;
	}


	public void prepararPartida() {
		System.out.println("Preparant partida...");
		for (int i=0;i<numeroDeJugadors;i++) {
			Conjunt<Integer> cartro=generarCartro();
			jugadors[i].setCartro(cartro);
		}
		bolesCantades=new ConjuntVectorImpl<Integer>(numeroDeBoles);
	}


	public String jugarPartida() {
		System.out.println("Inici partida...");
		String guanyador=null;
		while (guanyador==null) {
			int numeroCantat=treureNumeroDelBombo();
			System.out.println("Cantat el nmero "+numeroCantat);
			for (int i=0;i<numeroDeJugadors && guanyador==null;i++) {
				jugadors[i].notificaNumeroCantat(numeroCantat);
				if (jugadors[i].cartroComplet())
					guanyador=jugadors[i].getNom();
			}
		}
		System.out.println("Partida acabada");
		return guanyador;
	}


	protected Conjunt<Integer> generarCartro() {
		Conjunt<Integer> cartro=new ConjuntVectorImpl<Integer>(midaCartro);
		for (int n=1;n<midaCartro;n++)
			cartro.afegir(generadorNumerosCartro.nextInt(numeroDeBoles)+1);
		return cartro;
	}


	protected int treureNumeroDelBombo() {
		int numero=generadorNumerosCartro.nextInt(numeroDeBoles)+1;
		while (bolesCantades.hiEs(numero))
			numero=generadorNumerosCartro.nextInt(numeroDeBoles)+1;
		bolesCantades.afegir(numero);
		return numero;
	}


	public static void main(String[] args) {
		Bingo bingo=new Bingo(4,100,10);
		bingo.nouJugador("Joan");
		bingo.nouJugador("Ana");
		bingo.nouJugador("Maria");
		bingo.nouJugador("Miquel");
		bingo.prepararPartida();
		String guanyador=bingo.jugarPartida();
		System.out.println("El guanyador de la partida s: "+guanyador);
	}

}
