package uoc.ei.exemples.modul2;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Matriu {

	private double[][] elements;
	private int m,n;


	public Matriu (int m, int n) {
        this.m = m;
        this.n = n;
        elements = new double[m][n];
      }


    public void set(int i, int j, double s) {
        elements[i][j] = s;
     }


    public double get(int i, int j) {
        return elements[i][j];
     }


    /**
     * #prec B.m==n
     * @param B
     * @return
     */

    public Matriu multiplicarPer(Matriu B) {
    	Matriu X = new Matriu(m,B.n);
    	for (int j = 0; j < B.n; j++) {
    		for (int i = 0; i < m; i++) {
    			double s = 0;
    			for (int k = 0; k < n; k++) {
    				s += get(i,k)*B.get(k,j);
    			}
    			X.set(i,j,s);
    		}
    	}
    	return X;
    }


    public String toString() {
    	StringBuffer sb=new StringBuffer("(");
    	for(int i=0;i<m;i++) {
    		sb.append("(");
    		for(int j=0;j<n;j++) {
    			sb.append(elements[i][j]);
    			if (j<n-1) sb.append(", ");
    		}
    		sb.append(")");
    	}
		sb.append(")");
		return sb.toString();
    }


    public static void main(String[] args) {
    	Matriu m=new Matriu(2,3);
    	Matriu n=new Matriu(3,2);
    	m.set(0,0,2);
    	m.set(0,1,-3);
    	m.set(0,2,1);
    	m.set(1,0,6);
    	m.set(1,1,5);
    	m.set(1,2,3);
    	n.set(0,0,1);
    	n.set(0,1,-2);
    	n.set(1,0,5);
    	n.set(1,1,8);
    	n.set(2,0,3);
    	n.set(2,1,4);
    	System.out.println("M = "+m);
    	System.out.println("N = "+n);
    	Matriu resultat=m.multiplicarPer(n);
    	System.out.println("M x N = "+resultat);
    }

}
