package uoc.ei.exemples.modul3.cua;

import java.io.IOException;
import java.util.StringTokenizer;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class CuaOperacions {

	Cua<Operacio> operacions;

	protected CuaOperacions() {
		operacions=crearCua();
		crearProcessador();
	}


	protected Cua<Operacio> crearCua() {
		return new CuaVectorImpl<Operacio>();
	}


	protected void crearProcessador() {
		Thread processador = new Processador(operacions);
		// aix fa que quan el programa principal s'acaba,
		// el processador tamb acaba (encara que quedin
		// operacions per realitzar)
		processador.setDaemon(true);
		processador.start();
	}


	public void llegirOperacions() {
		boolean fi=false;
		System.out.println("Simulador d'una cua de processament.");
		System.out.println("Unicament realitza sumes.");
		System.out.println("Introdueix fi per acabar.");
		try {
			while (!fi) {
				String str=Utilitats.llegirString("Introdueix dos enters a sumar (separats per espai): ",System.in);
				if (str.equalsIgnoreCase("fi"))
					fi=true;
				else {
					StringTokenizer tk=new StringTokenizer(str," ");
					if (tk.countTokens()!=2)
						System.out.println("Nombre de enters diferent de dos, torna-ho a provar!");
					try {
						long op1=Long.parseLong(tk.nextToken());
						long op2=Long.parseLong(tk.nextToken());
						Operacio op=new Suma(op1,op2);
						System.out.println("encuant operaci: "+op);
						// Aquest bloc de sincronitzaci s necessari per a evitar que el thread
						// del processador i el d'usuari (aquest main) intentin accedir a la vegada
						// a la cua.
						synchronized (operacions) {
							operacions.encuar(op);
							System.out.println("nombre d'operacions pendents: "+operacions.nombreElems());
						}
					} catch (NumberFormatException e) {
						System.out.println("Problema al llegir els dos enters de: "+str);
						System.out.println("Torna-ho a provar!");
					}
				}
			}
		} catch (IOException e) {
			System.out.println("Error al llegir de l'entrada. Avortant l'execuci del programa:"+e);
		}
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		CuaOperacions programaPrincipal=new CuaOperacions();
		programaPrincipal.llegirOperacions();
	}

}
