package uoc.ei.exemples.modul3.llista;

import java.io.IOException;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class LlistaEncadenadaAmbIterador<E> extends LlistaEncadenada<E> {

	private static final long serialVersionUID = 1;


	public Iterador<E> elements() {
		return new IteradorLlista<E>(this);
	}


	public String toString() {
		StringBuffer sb=new StringBuffer();
		Iterador<E> iter=elements();
		while (iter.hiHaSeguent()) {
			sb.append(iter.seguent());
			if (iter.hiHaSeguent())
				sb.append(", ");
		}
		return sb.toString();
	}


	protected static class IteradorLlista<EI> implements Iterador<EI> {

		private static final long serialVersionUID = 1;

		private NodeEncadenat<EI> darrer;
		private NodeEncadenat<EI> seguent;

		IteradorLlista(LlistaEncadenadaAmbIterador<EI> ll) {
			this.darrer=ll.darrer;
			if (darrer!=null)
				seguent=darrer.getSeguent();
		}

		public boolean hiHaSeguent() {
			return seguent!=null;
		}

		public EI seguent() throws ExcepcioPosicioInvalida {
			NodeEncadenat<EI> aux=seguent;
			seguent = seguent==darrer ? null : seguent.getSeguent();
			return aux.getElem();
		}
	}


	public static void main(String[] args) {
		System.out.println("Introdueix nombres naturals a afegir al conjunt");
		boolean sortir=false;
		Llista<Integer> ll=new LlistaEncadenadaAmbIterador<Integer>();
		while (!sortir) {
			try {
				String elem=Utilitats.llegirString("Introdueix un nombre a afegir al final de la llista (o \"fi\" per acabar): ",System.in);
				sortir=elem.equalsIgnoreCase("fi");
				if (!sortir)
					ll.afegirAlFinal(Integer.parseInt(elem));
			} catch (NumberFormatException e) {
				System.out.println("El text introdut no s un nombre, torna-ho a provar.");
			} catch (IOException e) {
				System.out.println("Problema amb l'entrada, avortant el programa");
				sortir=true;
			}
		}
		System.out.println("La llista resultant s: "+ll);
	}

}
