
package uoc.ei.exemples.modul3.pila;

import uoc.ei.tads.*;

/** Representaci d'un document com un vector de pgines.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Document {

	Pagina[] pagines;
	int numPagines;


	Document(int numPagines) {
		pagines=new Pagina[numPagines];
		numPagines=0;
	}


	public void afegir(Pagina pagina) {
		pagines[numPagines]=pagina;
		numPagines++;
	}


	public boolean estaPle() { return numPagines==pagines.length; }


	protected Document capgirar() {
		Document documentCapgirat=new Document(pagines.length);
		Pila<Pagina> pila=new PilaVectorImpl<Pagina>(pagines.length);
		for(int i=0;i<numPagines;i++)
			pila.empilar(pagines[i]);
		while(!pila.estaBuit())
			documentCapgirat.afegir(pila.desempilar());
		return documentCapgirat;
	}


	public void imprimir(boolean ordreInvers) {
		Document docOrdreAdequat=
			ordreInvers ? capgirar() : this;
		System.out.println(docOrdreAdequat.toString());
	}


	public String toString() {
		StringBuffer sb=new StringBuffer();
		for(int i=0;i<numPagines;i++)
			sb.append(pagines[i].toString());
		return sb.toString();
	}


}
