package uoc.ei.exemples.modul3.referencia;


/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Persona {

	String nom;
	Persona pare;
	Persona mare;


	public Persona(String nom) {
		this.nom=nom;
		mare=null;
		pare=null;
	}


	public Persona(String nom,Persona mare,Persona pare) {
		this.nom=nom;
		this.mare=mare;
		this.pare=pare;
	}


	public String getNom() { return nom; }
	public Persona getMare() { return mare; }
	public Persona getPare() { return pare; }


	protected String familiaToString() {
		String familia="";
		if (pare!=null || mare!=null) {
			familia+=" descendent de ";
			if (pare!=null)
				familia+=pare.getNom();
			if (mare!=null && pare!=null)
				familia+=" i ";
			if (mare!=null)
				familia+=mare.getNom();
		}
		return familia;
	}


	public String toString() {
		return getNom()+familiaToString();
	}


	/** Crea un grup d'instncies de Persona, relacionades
	 * amb relacions parentesques entre elles i escriu
	 * la representaci textual d'aquests objectes.
	 * @param args
	 */

	public static void main(String[] args) {
		Persona aviPere=new Persona("Pere");
		Persona aviaPaquita=new Persona("Paquita");
		Persona mare=new Persona("Carme",aviPere,aviaPaquita);
		Persona tietPere=new Persona("Pere",aviPere,aviaPaquita);
		Persona pare=new Persona("Jordi");
		Persona joan=new Persona("Joan",mare,pare);
		System.out.println(aviPere);
		System.out.println(aviaPaquita);
		System.out.println(tietPere);
		System.out.println(mare);
		System.out.println(pare);
		System.out.println(joan);
	}


}
