package uoc.ei.exemples.modul4;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ArbreGeneralVectorExtImpl<E> extends ArbreAbstracte<E> {


	private Node<E> arrel;
	private int nElements;


	public ArbreGeneralVectorExtImpl() {
		super();
		arrel=null;
		nElements=0;
	}


	public Posicio<E> arrel() {
		return arrel;
	}


	public Recorregut<E> fills(Posicio<E> pare) {
		return ((Node<E>)pare).fills();
	}


	public Posicio<E> afegir(Posicio<E> pare, E elem) {
		Node<E> fill=new Node<E>(elem);
		if (pare==null)
			arrel=fill;
		else
			((Node<E>)pare).afegirFill(fill);
		nElements++;
		return fill;
	}


	public E reemplacar(Posicio<E> pos, E elem) {
		E elemAnterior=pos.getElem();
		Node<E> node=(Node<E>)pos;
		node.setElem(elem);
		return elemAnterior;
	}


	/** Les posicions no sn intercanviades, nicament els seus valors.
	 */

	public void intercanviar(Posicio<E> pos1, Posicio<E> pos2) {
		Node<E> node1=(Node<E>)pos1;
		Node<E> node2=(Node<E>)pos2;
		E aux=node1.getElem();
		node1.setElem(node2.getElem());
		node2.setElem(aux);
	}


	public void esborrar(Posicio<E> pare, Posicio<E> fill) {
		if (pare==null)
			arrel=null;
		else
			((Node<E>)pare).esborrarFill((Node<E>)fill);
		nElements-=nombreElems(fill);
	}


	public int nombreElems() {
		return nElements;
	}


	protected static class Node<EN> implements Posicio<EN> {

		private EN element;
		int nfills;
		private Node<EN>[] fills;


		public Node(EN element) {
			this.element=element;
			fills=null;
			nfills=0;
		}


		public EN getElem() { return element; }
		public void setElem(EN element) { this.element=element; }
		public int numeroDeFills() { return nfills; }


		public Recorregut<EN> fills() {
			return new RecorregutVectorImpl<EN>(fills,nfills,0);
		}


		public void afegirFill(Node<EN> fill) {
			if (fills==null || nfills==fills.length)
				extendreVectorFills();
			fills[nfills]=fill;
			nfills++;
		}


		public void esborrarFill(Node<EN> fill) {
			int index=0;
			while (fills[index]!=fill)
				index++;
			while (index<nfills-1)
				fills[index]=fills[index+1];
			fills[index]=null;
		}


		private void extendreVectorFills() {
			if (fills==null) fills=(Node<EN>[])new Node[1];
			else {
				Node<EN>[] aux=(Node<EN>[])new Node[fills.length*2];
				for (int i=0;i<fills.length;i++)
					aux[i]=fills[i];
				fills=aux;
			}
		}

		public String toString() { return element.toString(); }

	}

}
