package uoc.ei.exemples.modul4;

import java.io.IOException;
import java.util.StringTokenizer;
import uoc.ei.tads.ArbreBinariEncadenatImpl;
import uoc.ei.tads.ArbreGeneralDelegImpl;
import uoc.ei.tads.Pila;
import uoc.ei.tads.PilaVectorImpl;
import uoc.ei.tads.Posicio;
import uoc.ei.tads.Utilitats;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ArbreLocalitzacions extends ArbreGeneralDelegImpl<String> {


	public ArbreLocalitzacions() {
		super();
	}


	public ArbreLocalitzacions(String arbreEnText) {
		super();
		llegir(arbreEnText);
	}


	protected void llegir(String arbreEnText) {
		Pila<Posicio<String>> antecessors=new PilaVectorImpl<Posicio<String>>();
		StringTokenizer tokenizer=new StringTokenizer(arbreEnText);
		// agafem el nom de l'arrel i creem el node arrel
		String nom=tokenizer.nextToken();
		Posicio<String> posicioActual=afegir(null,nom);
		while (tokenizer.hasMoreTokens()) {
			nom=tokenizer.nextToken();
			if (nom.equals("SUB"))
				antecessors.empilar(posicioActual);
			else if (nom.equals("FSUB"))
				antecessors.desempilar();
			else {
				Posicio<String> pare=antecessors.cim();
				posicioActual=afegir(pare,nom);
			}
		}
	}


	public static void main(String args[]) {
		ArbreLocalitzacions arbre=new ArbreLocalitzacions("Catalunya SUB VallsOriental SUB Montmel FSUB Barcelons SUB Barcelona SUB NouBarris Carmel Grcia Sarri FSUB LHospitalet FSUB Bages");
		System.out.println("L'arbre resultant s: "+arbre);
	}

}
