package uoc.ei.exemples.modul4.recorreguts;

import uoc.ei.tads.*;


/** Aquesta classe exten la classe RecorregutsArbre amb els recorreguts bsics
 * sobre arbres disponibles nicament per a arbre binaris.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 * @param <E>
 */

public abstract class RecorregutsArbreBinari<E> extends RecorregutsArbre<E> {


	public void preordre(ArbreBinari<E> arbre) {
		if (!arbre.estaBuit())
			preordre(arbre,arbre.arrel());
	}


	public void inordre(ArbreBinari<E> arbre) {
		if (!arbre.estaBuit())
			inordre(arbre,arbre.arrel());
	}


	public void postordre(ArbreBinari<E> arbre) {
		if (!arbre.estaBuit())
			postordre(arbre,arbre.arrel());
	}


	public void preordre(ArbreBinari<E> arbre,Posicio<E> p) {
		Posicio<E> fillDret=arbre.fillDret(p);
		Posicio<E> fillEsquerre=arbre.fillEsquerre(p);
		tractarPosicio(p);
		if (fillEsquerre!=null) preordre(arbre,fillEsquerre);
		if (fillDret!=null) preordre(arbre,fillDret);
	}


	public void inordre(ArbreBinari<E> arbre,Posicio<E> p) {
		Posicio<E> fillDret=arbre.fillDret(p);
		Posicio<E> fillEsquerre=arbre.fillEsquerre(p);
		if (fillEsquerre!=null) inordre(arbre,fillEsquerre);
		tractarPosicio(p);
		if (fillDret!=null) inordre(arbre,fillDret);
	}


	public void postordre(ArbreBinari<E> arbre,Posicio<E> p) {
		Posicio<E> fillDret=arbre.fillDret(p);
		Posicio<E> fillEsquerre=arbre.fillEsquerre(p);
		if (fillEsquerre!=null) postordre(arbre,fillEsquerre);
		if (fillDret!=null) postordre(arbre,fillDret);
		tractarPosicio(p);
	}

}
