package uoc.ei.exemples.modul4.recorreguts.inordre;

import java.util.Date;
import uoc.ei.exemples.modul4.recorreguts.*;
import uoc.ei.tads.*;


/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ArbreTasques extends ArbreBinariEncadenatImpl<Tasca> {

	public void planificarTasques(Date inici) {
		PlanificadorTasques planificador=new PlanificadorTasques(inici);
		planificador.inordre(this);
	}


	/** Tal com es comenta als materials, aquesta classe disposa d'un atribut
	 * especial que fa referncia a l'anterior posici visitada. Aquesta tcnica
	 * ens permet tenir un tractar posicio fora senzill. Noteu per que aix
	 * imposa una restricci tamb: una instncia de PlanificacioTasques noms
	 * ens permetr fer un recorregut a la vegada!!!
	 * @author Jordi
	 */

	protected class PlanificadorTasques extends RecorregutsArbreBinari<Tasca> {

		Date inici;
		Tasca anterior;

		PlanificadorTasques(Date inici) { this.inici=inici; }

		protected void inicialitzarRecorregut() { anterior=null; }

		protected void tractarPosicio(Posicio<Tasca> posicio) {
			Tasca tasca=posicio.getElem();
			if (anterior!=null) {
				long inici=anterior.getInici().getTime()+anterior.getDuradaMinuts()*60000;
				tasca.setInici(new Date(inici));
			}
			else
				tasca.setInici(inici);
			anterior=tasca;
		}
	}


	protected static void popularArbreExemple(ArbreTasques arbre) {
		Posicio<Tasca> pintar=arbre.afegir(null,new Tasca("Pintar",20));
		Posicio<Tasca> enguixar=arbre.afegir(pintar,new Tasca("Enguixar",30));
		arbre.afegir(pintar,new Tasca("Netejar",7));
		arbre.afegir(enguixar,new Tasca("Instal.laci Elctrica",80));
		arbre.afegir(enguixar,new Tasca("Tapar Forats",15));
	}


	public static void main(String[] args) {
		ArbreTasques arbre=new ArbreTasques();
		popularArbreExemple(arbre);
		Date inici=new Date();
		arbre.planificarTasques(inici);
		System.out.println("L'arbre desprs de planificar les tasques ha quedat: "+arbre);
	}

}
