package uoc.ei.exemples.modul4.recorreguts.nivells;

import java.io.IOException;

import uoc.ei.exemples.modul4.ArbreGeneralVectorExtImpl;
import uoc.ei.exemples.modul4.recorreguts.RecorregutsArbre;
import uoc.ei.tads.*;


/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Departament extends ArbreGeneralVectorExtImpl<Empleat> {

	public void repartirPlaces(Llista<String> places) {
		RepartimentPlaces repartiment=new RepartimentPlaces(places);
		repartiment.perNivells(this);
	}


	protected class RepartimentPlaces extends RecorregutsArbre<Empleat> {

		private Llista<String> placesParking;
		Iterador<String> iteradorPlaces;

		public RepartimentPlaces(Llista<String> placesParking) {
			this.placesParking=placesParking;
		}

		protected void inicialitzarRecorregut() {
			iteradorPlaces=placesParking.elements();
		}

		protected void tractarPosicio(Posicio<Empleat> posicio) {
			String placaDesignada="NO";
			if (iteradorPlaces.hiHaSeguent())
				placaDesignada=iteradorPlaces.seguent();
			posicio.getElem().setPlacaParking(placaDesignada);
		}
	}


	public static void popularArbreExemple(Departament arbre) {
		Posicio<Empleat> matt=arbre.afegir(null,new Empleat("Matt"));
		arbre.afegir(matt,new Empleat("Ned"));
		Posicio<Empleat> apu=arbre.afegir(matt,new Empleat("Apu"));
		Posicio<Empleat> homer=arbre.afegir(apu,new Empleat("Homer"));
		Posicio<Empleat> winnie=arbre.afegir(apu,new Empleat("Winnie"));
		arbre.afegir(winnie,new Empleat("Bart"));
		arbre.afegir(winnie,new Empleat("Lisa"));
		arbre.afegir(winnie,new Empleat("Maggie"));
	}


	public static void main(String[] args) {
		Departament arbre=new Departament();
		popularArbreExemple(arbre);
		Llista<String> places=new LlistaEncadenada<String>();
		places.afegirAlFinal("plaa A");
		places.afegirAlFinal("plaa B");
		places.afegirAlFinal("plaa C");
		arbre.repartirPlaces(places);
		System.out.println("El departament desprs d'assignar les places ha quedat: "+arbre);
	}

}
