package uoc.ei.exemples.modul4.recorreguts.postordre;

import uoc.ei.exemples.modul4.recorreguts.RecorregutsArbre;
import uoc.ei.tads.ArbreBinariEncadenatImpl;
import uoc.ei.tads.Posicio;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Expresio extends ArbreBinariEncadenatImpl<ElementExpressio> {

	public double avaluar() {
		Avaluador avaluador=new Avaluador();
		avaluador.postordre(this);
		return arrel().getElem().getResultat();
	}


	protected class Avaluador extends RecorregutsArbre<ElementExpressio> {

		protected void tractarPosicio(Posicio<ElementExpressio> posicio) {
			if (!esFulla(posicio)) {
				Operacio op=(Operacio)posicio.getElem();
				double fe=fillEsquerre(posicio).getElem().getResultat();
				double fd=fillDret(posicio).getElem().getResultat();
				switch (op.getOperador()) {
					case '+' : op.setResultat(fe+fd);
						break;
					case '-' : op.setResultat(fe-fd);
						break;
					case '*' : op.setResultat(fe*fd);
						break;
					case '/' : op.setResultat(fe/fd);
						break;
				}
			}
		}
	}


	public static void popularArbreExemple(Expresio arbre) {
		Posicio<ElementExpressio> op1=arbre.afegir(null,new Operacio('+'));
		arbre.afegirFillEsquerre(op1,new Valor(3));
		Posicio<ElementExpressio> op2=arbre.afegirFillDret(op1,new Operacio('*'));
		arbre.afegirFillEsquerre(op2,new Valor(5));
		Posicio<ElementExpressio> op3=arbre.afegirFillDret(op2,new Operacio('+'));
		arbre.afegirFillEsquerre(op3,new Valor(6));
		arbre.afegirFillDret(op3,new Valor(1));
	}


	public static void main(String[] args) {
		Expresio arbre=new Expresio();
		popularArbreExemple(arbre);
		System.out.println("L'expressi s: "+arbre);
		double resultat=arbre.avaluar();
		System.out.println("El resultat d'avaluar l'expressi s: "+resultat);
	}

}
