package uoc.ei.exemples.modul4.recorreguts.preordre;

import java.io.IOException;
import java.io.StringReader;

import uoc.ei.exemples.modul4.recorreguts.RecorregutsArbre;
import uoc.ei.tads.*;


/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ArbreTasques extends ArbreGeneralDelegImpl<Tasca> {

	public void repartirTasques() {
		RepartimentTasques repartiment=new RepartimentTasques();
		repartiment.preordre(this);
	}


	protected class RepartimentTasques extends RecorregutsArbre<Tasca> {

		protected void tractarPosicio(Posicio<Tasca> posicio) {
			double recursosAbsolutsPare=posicio.getElem().getRecursosAbsoluts();
			Recorregut<Tasca> fills=fills(posicio);
			while (fills.hiHaSeguent()) {
				Tasca tascaFilla=fills.seguent().getElem();
				tascaFilla.setRecursosAbsoluts(recursosAbsolutsPare*tascaFilla.getRecursosPercentatge()/100);
			}
		}
	}


	public static void popularArbreExemple(ArbreTasques arbre) {
		Posicio<Tasca> reformar=arbre.afegir(null,new Tasca("Reformar",100));
		Posicio<Tasca> parets=arbre.afegir(reformar,new Tasca("Parets",35));
		arbre.afegir(reformar,new Tasca("Terra",50));
		arbre.afegir(reformar,new Tasca("Llums",15));
		arbre.afegir(parets,new Tasca("TaparForats",30));
		arbre.afegir(parets,new Tasca("Pintar",70));
	}


	public static void main(String[] args) {
		ArbreTasques arbre=new ArbreTasques();
		popularArbreExemple(arbre);
		try {
			String str=Utilitats.llegirString("Introdueix els recursos absoluts: ",System.in);
			double absoluts=Double.parseDouble(str);
			arbre.arrel().getElem().setRecursosAbsoluts(absoluts);
			arbre.repartirTasques();
			System.out.println("L'arbre desprs de repartir les tasques ha quedat: "+arbre);
		} catch (IOException e) {
			System.out.println("Error al llegir de l'entrada: "+e);
		}
	}

}
