package uoc.ei.exemples.modul5;

import uoc.ei.tads.algorismes.AlgorismeOrdenacio;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class HeapSortSenseCua<E> implements AlgorismeOrdenacio<E> {


	public void ordenar(E[] vector, int n) {
		construirHeap(vector,n);
		consumirHeap(vector,n);
	}


	private void construirHeap(E[] vector,int n) {
		for (int i = n/2; i >= 0; i--)
			enfonsar(vector,i,n);
	}


	private void consumirHeap(E[] vector,int n) {
		for (int i = n-1; i >= 0; i--) {
			intercanviar(vector,0,i);
			enfonsar(vector,0,i);
		}
	}


	final private void enfonsar(E[] vector,int i,int n) {
		if (i*2+1<n) {
			int fill=triarFillAIntercanviar(vector,i,n);
			if (comparar(vector,i,fill)<0) {
				intercanviar(vector,i,fill);
				enfonsar(vector,fill,n);
			}
		}
	}


	final private int triarFillAIntercanviar(E[] vector,int i,int n) {
		int fe=i*2+1;
		int fd=i*2+2;
		if (fd>=n) return fe;
		return comparar(vector,fe,fd)>0 ? fe : fd;
	}


	final private int comparar(E[] vector,int i,int j) {
		return ((Comparable<E>)vector[i]).compareTo(vector[j]);
	}


	final private int comparar(E a,E b) {
		return ((Comparable<E>)a).compareTo(b);
	}


	 final private void intercanviar(E[] vector,int i,int j) {
		 E aux=vector[i];
		 vector[i]=vector[j];
		 vector[j]=aux;
	 }



}
