package uoc.ei.exemples.modul5;

import uoc.ei.tads.algorismes.AlgorismeOrdenacio;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class HeapSortSenseCua2<E> implements AlgorismeOrdenacio<E> {


	private int triaFillAIntercanviar(E[] vector,int i,int n) {
		int fe=i*2+1;
		int fd=i*2+2;
		if (fd>=n) return fe;
		return comparar(vector,fe,fd)>0 ? fe : fd;
	}


	private int comparar(E[] vector,int i,int j) {
		return ((Comparable<E>)vector[i]).compareTo(vector[j]);
	}


	private int comparar(E a,E b) {
		return ((Comparable<E>)a).compareTo(b);
	}


	private void enfonsar(E[] vector,int i,int n) {
		E temp=vector[i];
		boolean sortir=false;
		while (i*2+1<=n && !sortir) {
			int fill=triaFillAIntercanviar(vector,i,n);
			if (comparar(temp,vector[fill])<0) {
				vector[i]=vector[fill];
				i=fill;
			}
			else
				sortir=true;
		}
		vector[i]=temp;
	}


	private void afegir(E[] vector,int i,int n) {
		E temp=vector[i];
		boolean sortir=false;
		while (i>0 && !sortir) {
			int pare=(i-1)/2;
			if (comparar(vector[pare],temp)<0) {
				vector[i]=vector[pare];
				i=pare;
			}
			else
				sortir=true;
		}
		vector[i]=temp;
	}


	public void ordenar(E[] vector, int n) {
		for(int i=1;i<n;i++)
			afegir(vector,i,n);
		for(int i=n-1;i>=1;i--) {
			E temp=vector[0];
			vector[0]=vector[i];
			vector[i]=temp;
			enfonsar(vector,0,i-1);
		}
	}

}
