package uoc.ei.exemples.modul6;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class PilaEncadenadaImpl<E>  implements Pila<E> {

   protected Llista<E> elements;


   public PilaEncadenadaImpl() {
	   elements=new LlistaEncadenada<E>();
   }

   public int nombreElems() { return  elements.nombreElems(); }

   public boolean estaBuit() { return  elements.estaBuit(); }

   public void empilar(E elem) {
	   elements.afegirAlPrincipi(elem);
   }

   public E desempilar() {
	   return elements.esborrarPrimer();
   }

   public E cim() {
      return  elements.elements().seguent();
   }

   public Iterador<E> elements() {
   		return elements.elements();
   }

   public String toString()
   {
      StringBuffer buffer = new StringBuffer();
      buffer.append("{PILA:");
      for (Iterador it = elements(); it.hiHaSeguent(); ) {
         buffer.append(it.seguent());
         if (it.hiHaSeguent()) buffer.append(',');
      }
      buffer.append("}");
      return  buffer.toString();
   }
}
