package uoc.ei.exemples.modul6;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class TaulaDispersioSimbols extends TaulaDispersio<String,Pila<PropietatsSimbol>> {

	private static final int MIDA_TAULA = 1023;

	public TaulaDispersioSimbols() {
		super(MIDA_TAULA);
	}

	protected int calcularIndexTaula(String clau) {
		int hash=0;
		for(int i=0;i<clau.length();i++)
			hash+=ordinal(clau.charAt(i));
		hash%=MIDA_TAULA;
		return hash;
	}


	private int ordinal(char c) {
		if (c=='_') return 0;
		if (Character.isDigit(c)) return 1+c-'0';
		return 11+c-'a';
	}

}
