package uoc.ei.exemples.modul6;

import uoc.ei.exemples.modul6.PropietatsSimbol.Categoria;
import uoc.ei.exemples.modul6.PropietatsSimbol.Tipus;
import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class TaulaSimbolsImpl implements TaulaSimbols {

	private int numBlocsAniuats;
	private TaulaDispersioSimbols taula;

	public TaulaSimbolsImpl() {
		numBlocsAniuats=0;
		taula=new TaulaDispersioSimbols();
	}


	public void entra() {
		numBlocsAniuats++;
	}


	public void surt() {
		Llista<String> idsAEliminar=new LlistaEncadenada<String>();
		Iterador<String> ids=taula.claus();
		while (ids.hiHaSeguent()) {
			String id=ids.seguent();
			Pila<PropietatsSimbol> pila=taula.consultar(id);
			PropietatsSimbol props=pila.cim();
			if (props.getBloc()==numBlocsAniuats) {
				pila.desempilar();
				if (pila.estaBuit())
					idsAEliminar.afegirAlFinal(id);
			}
		}
		ids=idsAEliminar.elements();
		while (ids.hiHaSeguent()) {
			String id=ids.seguent();
			taula.esborrar(id);
		}
	}


	public void declara(String id, Categoria categoria, Tipus tipus, int dimensio) {
		id=id.toLowerCase();
		PropietatsSimbol props=new PropietatsSimbol(numBlocsAniuats,categoria,tipus,dimensio);
		Pila<PropietatsSimbol> pila=taula.consultar(id);
		if (pila==null) {
			pila=new PilaEncadenadaImpl<PropietatsSimbol>();
			taula.afegir(id,pila);
		}
		pila.empilar(props);
	}

	public PropietatsSimbol consulta(String id) {
		id=id.toLowerCase();
		Pila<PropietatsSimbol> pila=taula.consultar(id);
		if (pila==null)
			return null;
		return pila.cim();
	}

}
