package uoc.ei.exemples.modul6.jcf;

import java.util.*;

import uoc.ei.exemples.modul6.PropietatsSimbol;
import uoc.ei.exemples.modul6.TaulaSimbols;
import uoc.ei.exemples.modul6.PropietatsSimbol.Categoria;
import uoc.ei.exemples.modul6.PropietatsSimbol.Tipus;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class TaulaSimbolsImpl implements TaulaSimbols {

	private int numBlocsAniuats;
	private Map<String,Stack<PropietatsSimbol>> taula;

	public TaulaSimbolsImpl() {
		numBlocsAniuats=0;
		taula=new TaulaDispersioSimbols();
	}


	public void entra() {
		numBlocsAniuats++;
	}


	public void surt() {
		Collection<String> idsAEliminar=new ArrayList<String>();
		Iterator<String> ids=taula.keySet().iterator();
		while (ids.hasNext()) {
			String id=ids.next();
			Stack<PropietatsSimbol> pila=taula.get(id);
			PropietatsSimbol props=pila.peek();
			if (props.getBloc()==numBlocsAniuats) {
				pila.pop();
				if (pila.empty())
					idsAEliminar.add(id);
			}
		}
		ids=idsAEliminar.iterator();
		while (ids.hasNext()) {
			String id=ids.next();
			taula.remove(id);
		}
	}


	public void declara(String id, Categoria categoria, Tipus tipus, int dimensio) {
		id=id.toLowerCase();
		PropietatsSimbol props=new PropietatsSimbol(numBlocsAniuats,categoria,tipus,dimensio);
		Stack<PropietatsSimbol> pila=taula.get(id);
		if (pila==null) {
			pila=new Stack<PropietatsSimbol>();
			taula.put(id,pila);
		}
		pila.push(props);
	}

	public PropietatsSimbol consulta(String id) {
		id=id.toLowerCase();
		Stack<PropietatsSimbol> pila=taula.get(id);
		if (pila==null)
			return null;
		return pila.peek();
	}

}
