package uoc.ei.exemples.modul8;

import uoc.ei.tads.ClauValor;
import uoc.ei.tads.algorismes.grafs.CaminsMinims;
import uoc.ei.tads.grafs.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ProvaCaminsMinims {

	public static void main(String[] args) {
		GrafDirigit<String,Integer> xarxaCarreteres=new GrafDirigitImpl<String,Integer>();
		Vertex<String> madrid=xarxaCarreteres.crearVertex("Madrid");
		Vertex<String> villar=xarxaCarreteres.crearVertex("Villar");
		Vertex<String> collado=xarxaCarreteres.crearVertex("Collado");
		Vertex<String> montes=xarxaCarreteres.crearVertex("Montes");
		Vertex<String> aldea=xarxaCarreteres.crearVertex("Aldea");
		Aresta<Integer,String> mv=xarxaCarreteres.crearAresta(madrid,villar);
		mv.setEtiqueta(75);
		Aresta<Integer,String> mc=xarxaCarreteres.crearAresta(madrid,collado);
		mc.setEtiqueta(60);
		Aresta<Integer,String> mn=xarxaCarreteres.crearAresta(madrid,montes);
		mn.setEtiqueta(20);
		Aresta<Integer,String> nv=xarxaCarreteres.crearAresta(montes,villar);
		nv.setEtiqueta(2);
		Aresta<Integer,String> nc=xarxaCarreteres.crearAresta(montes,collado);
		nc.setEtiqueta(30);
		Aresta<Integer,String> va=xarxaCarreteres.crearAresta(villar,aldea);
		va.setEtiqueta(200);
		Aresta<Integer,String> ca=xarxaCarreteres.crearAresta(collado,aldea);
		ca.setEtiqueta(30);
		CaminsMinims<String,Integer> ag=new CaminsMinims<String,Integer>();
		ClauValor<Vertex<String>,Number>[] distancies=ag.calcular(xarxaCarreteres,madrid);
		for(int i=0;i<distancies.length;i++) {
			System.out.println("La distancia mnima de "+madrid.getValor()+" a "+distancies[i].getClau().getValor()+" s "+distancies[i].getValor());
		}
	}

}
