package uoc.ei.exemples.modul8.academia;

import uoc.ei.tads.*;
import uoc.ei.tads.grafs.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class AssignaturesProfessor extends LlistaEncadenada<Vertex<Assignatura>> {

	private double credits;


	public AssignaturesProfessor() {
		credits=0;
	}


	public double getCredits() { return credits; }


	public Vertex<Assignatura> esborrarPrimer() {
		Vertex<Assignatura> assig=super.esborrarPrimer();
		credits-=assig.getValor().getCredits();
		return assig;
	}


	public Vertex<Assignatura> esborrar(Posicio<Vertex<Assignatura>> node) {
		Vertex<Assignatura> assig=super.esborrar(node);
		credits-=assig.getValor().getCredits();
		return assig;
	}


	public Vertex<Assignatura> esborrarSeguent(Posicio<Vertex<Assignatura>> node) {
		Vertex<Assignatura> assig=super.esborrarSeguent(node);
		credits-=assig.getValor().getCredits();
		return assig;
	}


	public Vertex<Assignatura> reemplacar(Posicio<Vertex<Assignatura>> node, Vertex<Assignatura> elem) {
		Vertex<Assignatura> old = super.reemplacar(node,elem);
		credits=credits-old.getValor().getCredits()+elem.getValor().getCredits();
		return old;
	}


	protected NodeEncadenat<Vertex<Assignatura>> novaPosicio(NodeEncadenat<Vertex<Assignatura>> node,Vertex<Assignatura> elem) {
		credits+=elem.getValor().getCredits();
		return super.novaPosicio(node,elem);
	}

}
