package uoc.ei.exemples.modul8.academia;

import uoc.ei.tads.*;
import uoc.ei.tads.grafs.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ProvaAcademiaElectricitat {


	public GrafAssignatures construirGrafAssignatures() {
		GrafAssignatures assignatures=new GrafAssignaturesImpl();
		Vertex<Assignatura> vA1=assignatures.crearVertex(new Assignatura("A1",3.5));
		Vertex<Assignatura> vA2=assignatures.crearVertex(new Assignatura("A2",3.5));
		Vertex<Assignatura> vA3=assignatures.crearVertex(new Assignatura("A3",3.5));
		Vertex<Assignatura> vA4=assignatures.crearVertex(new Assignatura("A4",3.5));
		Vertex<Assignatura> vA5=assignatures.crearVertex(new Assignatura("A5",6));
		assignatures.crearAresta(vA1,vA2);
		assignatures.crearAresta(vA1,vA3);
		assignatures.crearAresta(vA2,vA4);
		assignatures.crearAresta(vA3,vA4);
		assignatures.crearAresta(vA4,vA5);
		return assignatures;
	}


	public LlistaEncadenada<String> construirProfessors() {
		LlistaEncadenada<String> profes=new LlistaEncadenada<String>();
		profes.afegirAlFinal("P1");
		profes.afegirAlFinal("P2");
		return profes;
	}


	public void matricular(AcademiaElectricitat academia,String alumne,String assignatura) {
		try {
			academia.matricular(alumne,assignatura);
			System.out.println("L'alumne "+alumne+" ha matriculat l'assignatura "+assignatura);
		} catch (ExcepcioPrerequisitNoSatisfet e) {
			System.out.println(e.toString());
		}
	}


	public static void main(String[] args) {
		ProvaAcademiaElectricitat prova=new ProvaAcademiaElectricitat();
		GrafAssignatures assignatures=prova.construirGrafAssignatures();
		LlistaEncadenada<String> profes=prova.construirProfessors();
		AcademiaElectricitat academia=new AcademiaElectricitatImpl(assignatures,profes.elements());
		academia.imparteixAssignatura("P1","A1");
		academia.imparteixAssignatura("P1","A2");
		academia.imparteixAssignatura("P1","A5");
		academia.imparteixAssignatura("P2","A3");
		academia.imparteixAssignatura("P2","A4");
		academia.afegirAlumne("E1");
		prova.matricular(academia,"E1","A1");
		academia.assignaturaAprovada("E1","A1",8.0);
		prova.matricular(academia,"E1","A2");
		academia.assignaturaAprovada("E1","A2",6.0);
		prova.matricular(academia,"E1","A4");
		prova.matricular(academia,"E1","A3");
	}

}
