package uoc.ei.exemples.modul9.dns;


import uoc.ei.tads.Iterador;


/**
 * Interfcie DNS definida a l'enunciat de la prctica.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface DNS {
     /**
     * Mtode que dna d'alta un domini relacionant-lo amb una ip.
     *
     * @param domini objecte Domini que cont el domini. ex: "www.uoc.edu".
     * @param ip  cadena que cont l'adrea ip del domini. ex: "129.34.2.3".
     */
     public void altaDomini(Domini d, IP ip);

     /**
     * Mtode que dna de baixa un domini.
     *
     * @param domini objecte Domini que cont el domini. ex: "www.uoc.edu".
     */
     public void baixaDomini(Domini d);

     /**
     * Mtode que consulta l'adrea ip d'un domini.
     *
     * @param domini objecte Domini que cont el domini. ex: "www.uoc.edu".
     * @return ip  returna una cadena que cont l'adrea ip del domini. ex: "129.34.2.3".
     */
     public IP consultar(Domini d);

     /**
     * Mtode que consulta un dels dominis ms visitats.
     *
     * @param num posici dins del ranking (0..9).
     * @return domini retorna un objecte Domini que cont el nom del domini.
     */
     public Domini mesVisitats(int n);

     /**
     * Mtode que inicialitza un tld per a fer un recorregut.
     *
     * @param tld el tld del qual volem fer un recorregut.
     */
     public Iterador<Entitat> entitats(TLD t);

}
