package uoc.ei.exemples.modul9.dns;

import uoc.ei.tads.*;

/**
 * Classe que encapsula la representaci escollida per guardar els hosts de cadascuna de les entitats
 * d'TLD's.<br>
 * En aquesta versi s'ha usat la implementaci de les funcions encadenades redefinint el
 * mtode d'afegir per poder reorganitzar els hosts per a optimitzar les consultes dels ms recentment
 * consultats.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class DiccionariHosts extends DiccionariLlistaImpl<Host,InformacioHost> {

	/**
	 * Mtode que consulta les dades d'un Host a partir del seu domini. Est redefinint el mtode
	 * original de la FuncioEnc per permetre reordenar els hosts per optimitzar les consultes dels
	 * ms recentment consultats. <br>
	 * Per optimitzar les consultes simplement situem al principi el host consultat.
	 *
	 * @param clauElem el Domini del Host que volem consultar.
	 * @return ClauValor informaci del Host.
	 */
	public InformacioHost consultar(Host clau) {
		InformacioHost element = null;
		// consultem l'element (clonem implementaci de classe pare)
		RecorregutAmbAnterior<ClauValor<Host,InformacioHost>> r=cercaPosicio(clau);
		Posicio<ClauValor<Host,InformacioHost>> actual=r.actual();
		if (actual!=null) {
			element = actual.getElem().getValor();
			// esborrem l'element fent servir la posici anterior.
			// ho fem sempre i quan no es tracti del primer element!!!
			Posicio<ClauValor<Host,InformacioHost>> anterior=r.anterior();
			if (anterior!=null) {
				diccionari.esborrar(anterior);
				// el tornem a afegir al principi de la llista
				diccionari.afegirAlPrincipi(actual.getElem());
			}
		}
		return element;
	}

}