package uoc.ei.exemples.modul9.dns;

/**
 * Classe que conte la informaci que defineix una entitat (ex: "uoc").
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Entitat implements Comparable {
  private String entitat;

  /**
  * Constructor d'una Entitat a partir d'una cadena (ex "uoc").
  * @param s cadena que cont el nom de l'entitat (ex "uoc").
  */
  public Entitat(String s) {
    entitat=s;
  }

  /**
  * Mtode que permet comparar dues entitats. Necessari per poder afegir Entitats al ContEntitats (un arbre AVL).
  * @param o una altra entitat.
  */
  public int compareTo(Object o) {
    Entitat e=(Entitat)o;
    return entitat.compareTo(e.entitat);
  }

  /**
  * Mtode que retorna una cadena amb el nom de l'entitat.
  * @return String cadena amb el nom de l'entitat (ex "uoc").
  */
  public String toString() {
    return entitat;
  }
}