package uoc.ei.exemples.modul9.dns;

/**
 * Classe que conte la informaci que defineix el nom d'un host (ex: "www").
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Host implements Comparable{
  private String host;

  /**
  * Constructor d'un Host a partir d'una cadena (ex "www").
  * @param s cadena que cont el nom del host (ex "ww").
  */
  public Host(String s) {
    host=s;
  }

  /**
  * Mtode que permet comparar dos hosts. Necessari per poder afegir Hosts al ContHosts (FuncioEnd).
  * @param o un altre host.
  */
  public int compareTo(Object o) {
    Host h=(Host)o;
    return host.compareTo(h.host);
  }

  /**
  * Mtode que retorna una cadena amb el nom del host.
  * @return String cadena amb el nom del host (ex "www").
  */
  public String toString() {
    return host;
  }
}