package uoc.ei.exemples.modul9.dns;


/**
 * Classe que cont la informaci que defineix una adrea IP (ex: "100.23.98.255").
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class IP implements Comparable{
  private String ip;

  /**
  * Constructor d'una IP a partir d'una cadena (ex "100.23.98.255").
  * @param s cadena que cont l'adrea IP(ex "100.23.98.255").
  */
  public IP(String s) {
    ip=s;
  }

  /**
  * Mtode que permet comparar dos IP's.
  * @param o una altra IP.
  */
  public int compareTo(Object o) {
    IP i=(IP)o;
    return ip.compareTo(i.ip);
  }

  /**
  * Mtode que retorna una cadena amb l'adrea ip.
  * @return String cadena amb l'adrea ip (ex "100.23.98.255").
  */
  public String toString() {
    return ip;
  }
}