package uoc.ei.exemples.modul9.dns;

/**
 * Classe que agrupa la informaci necessria que hem de guardar de cada host.<br>
 * Inclou el domini, l'adrea ip i el nombre de visites.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class InformacioHost {
  Domini domini;
  IP ip;
  int numVisites;

  /**
  * Constructor d'un ContHost a partir d'un domini i una ip. El comptador de visites es posa a 0.
  * @param d Domini.
  * @param i IP.
  */
  public InformacioHost(Domini d, IP i) {
    domini=d;
    ip=i;
    numVisites=0;
  }

  /**
  * Mtode que incrementa el comptador de visites del Host.
  */
  public void visita() {numVisites++;}

  /**
  * Mtode que retorna el Domini del Host.
  * @return Domini el domini del host.
  */
  public Domini getDomini() {return domini;}

  /**
  * Mtode que retorna l'adrea IP del Host.
  * @return IP l'adrea ip del host.
  */
  public IP getIP() {return ip;}

  /**
  * Mtode que assigna l'adrea IP del Host.
  * @return IP l'adrea ip del host.
  */
  public void setIP(IP i) {ip=i;}

  /**
  * Mtode que retorna el nombre de visites del Host.
  * @return int nombre de visites del host.
  */
  public int getVisites() {return numVisites;}


  public String toString() {
	  return "[InfoHost: "+domini+","+ip+","+numVisites+"]";
  }
}