package uoc.ei.exemples.modul9.dns;

/**
 * Classe que cont la informaci que defineix un Top Level Domain o TLD(ex: "edu").
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class TLD implements Comparable{
  private String tld;

  /**
  * Constructor d'un TLD a partir d'una cadena (ex "edu").
  * @param s cadena que cont el nom del TLD (ex "edu").
  */
  public TLD(String s) {
    tld=s;
  }


  /**
  * Mtode que permet comparar dos TLD's.
  * @param o un altre TLD.
  */
  public int compareTo(Object o) {
    TLD t=(TLD)o;
    return tld.compareTo(t.tld);
  }


  /** Calcula el hashcode del TLD. Delega en el mtode
   * hashcode de String.
   */

  public int hashCode() {
	  return tld.hashCode();
  }


  /**
  * Mtode que retorna una cadena amb el nom del TLD.
  * @return String cadena amb el nom del tld (ex "edu").
  */
  public String toString() {
    return tld;
  }
}