package uoc.ei.exercicis.modul4;

import uoc.ei.exemples.modul4.recorreguts.preordre.*;
import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class Exercici2<E> {

	public int numeroDeFulles(Arbre<E> arbre) {
		return numeroDeFulles(arbre,arbre.arrel());
	}


	protected int numeroDeFulles(Arbre<E> arbre,Posicio<E> posicio) {
		int nFulles=0;
		if (arbre.esFulla(posicio))
			nFulles=1;
		else {
			Recorregut<E> fills=arbre.fills(posicio);
			while (fills.hiHaSeguent()) {
				Posicio<E> fill=fills.seguent();
				nFulles+=numeroDeFulles(arbre,fill);
			}
		}
		return nFulles;
	}


	public int numeroDeFulles(ArbreBinari<E> arbre) {
		return numeroDeFulles(arbre,arbre.arrel());
	}


	protected int numeroDeFulles(ArbreBinari<E> arbre,Posicio<E> posicio) {
		int nFulles=0;
		if (posicio!=null) {
			nFulles+=numeroDeFulles(arbre,arbre.fillEsquerre(posicio));
			nFulles+=numeroDeFulles(arbre,arbre.fillDret(posicio));
			if (nFulles==0)
				nFulles=1;
		}
		return nFulles;
	}


	public static void main(String[] args) {
		Exercici2<Tasca> exercici2=new Exercici2<Tasca>();
		// Fem servir com a exemple d'arbre l'arbre de tasques definit per a l'exemple
		// del recorregut en preordre
		ArbreTasques arbre=new ArbreTasques();
		ArbreTasques.popularArbreExemple(arbre);
		System.out.println("L'arbre s: "+arbre);
		System.out.println("I el seu nmero de fulles: "+exercici2.numeroDeFulles(arbre));
	}

}
