package uoc.ei.exercicis.modul5.exercici3;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ServeiImpresio {

	/** Contenidor per la cua */
	 private CuaAmbPrioritat<DocumentAmbPrioritat> cua;

	/** Identificador per a un nou document que arriba */
	 private int ident;


	 public ServeiImpresio() {
		 ident=0;
		 cua=new CuaAmbPrioritat<DocumentAmbPrioritat>();
	 }

	public CuaAmbPrioritat getCua(){
	  return(cua);
	 }


	 public int insertarDocument (Document documento, int prioridad) {
	    DocumentAmbPrioritat docP = new DocumentAmbPrioritat(documento, prioridad,  ident);
	    cua.encuar(docP);
	    System.out.println("Document amb identificador " + docP.getIdentificador() + " afegit a la llista");
	    return(ident++);
	 }


	 public void eliminarDocument(int id) {
	    Llista<DocumentAmbPrioritat> llistaAux = new LlistaEncadenada<DocumentAmbPrioritat>();
	    boolean trobat = false;
	    while(!cua.estaBuit() && !trobat) {
	    	DocumentAmbPrioritat docE = cua.desencuar();
	    	if(docE.getIdentificador()==id) trobat=true;
	    	else llistaAux.afegirAlFinal(docE);
	    }
	    Iterador<DocumentAmbPrioritat> docs=llistaAux.elements();
	    while (docs.hiHaSeguent())
	    	cua.encuar(docs.seguent());
	    System.out.println("Document amb identificador " + id + " eliminat");
	 }


	 public void enviarDocument () {
	  if(!cua.estaBuit()) {
	     DocumentAmbPrioritat docE = cua.desencuar();
	     imprimir(docE.getDocument());
	     System.out.println("Prioritat del doc impres: " + docE.getPrioritat());
	    }
	 }


	 private void imprimir(Document document) {
	     System.out.println(document);
	 }

}
