package uoc.ei.exercicis.modul9.exercici1;

import uoc.ei.tads.*;

/** Extensi d'una cua amb prioritat que permet modificar els valors
 * guardats a la cua i actualitzar la cua de manera que torni a estar
 * ordenada en temps logartmic.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class CuaAmbPrioritatActualitzable<E> extends CuaAmbPrioritat<E> {


	private LlistaEncadenada<ObservadorContenidorPosicional<E>> observadors;


	public CuaAmbPrioritatActualitzable() {
		super();
		observadors=new LlistaEncadenada<ObservadorContenidorPosicional<E>>();
	}

	public CuaAmbPrioritatActualitzable(int max) {
		super(max);
		observadors=new LlistaEncadenada<ObservadorContenidorPosicional<E>>();
	}

	public CuaAmbPrioritatActualitzable(java.util.Comparator<E> comparador) {
		super(comparador);
		observadors=new LlistaEncadenada<ObservadorContenidorPosicional<E>>();
	}

	public CuaAmbPrioritatActualitzable(int max, java.util.Comparator<E> comparador) {
		super(max,comparador);
		observadors=new LlistaEncadenada<ObservadorContenidorPosicional<E>>();
	}


	public void actualitzarPosicio(Posicio<E> posicio) {
		enfonsarElement(posicio);
		pujarElement(posicio);
	}


	public void afegirObservador(ObservadorContenidorPosicional observador) {
		observadors.afegirAlFinal(observador);
	}


	public void esborrarObservador(ObservadorContenidorPosicional observador) {
		Recorregut<ObservadorContenidorPosicional<E>> r=observadors.posicions();
		boolean trobat=false;
		Posicio<ObservadorContenidorPosicional<E>> p=null;
		while (r.hiHaSeguent() && !trobat) {
			p=r.seguent();
			trobat=p.getElem()==observador;
		}
		if (trobat)
			observadors.esborrar(p);
	}


	protected Posicio<E> novaDarreraPosicio(E elem) {
		Posicio<E> posicio=super.novaDarreraPosicio(elem);
		Iterador<ObservadorContenidorPosicional<E>> iter=observadors.elements();
		while (iter.hiHaSeguent()) {
			iter.seguent().notificarPosicioCreada(posicio);
		}
		return posicio;
	}


	protected Posicio<E> esborrarDarreraPosicio() {
		Posicio<E> posicio=super.esborrarDarreraPosicio();
		Iterador<ObservadorContenidorPosicional<E>> iter=observadors.elements();
		while (iter.hiHaSeguent()) {
			iter.seguent().notificarPosicioEsborrada(posicio);
		}
		return posicio;
	}


}
