package uoc.ei.exercicis.modul9.exercici1;

import uoc.ei.tads.Posicio;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class DadesAlumne implements Comparable<DadesAlumne> {

	private String nom;
	private Posicio<DadesAlumne> posicioHeap;
	private double notaAcumulada;
	private double credits;


	public DadesAlumne(String nom) {
		this.nom=nom;
		posicioHeap=null;
		notaAcumulada=0;
		credits=0;
	}


	public String getNom() { return nom; }
	public Posicio<DadesAlumne> getPosicioHeap() { return posicioHeap; }


	public double getNota() {
		if (credits>0)
			return notaAcumulada/credits;
		return 0;
	}


	public void novaNota(double credits,double nota) {
		notaAcumulada=notaAcumulada+credits*nota;
		this.credits+=credits;
	}


	public void setPosicioHeap(Posicio<DadesAlumne> posicio) {
		posicioHeap=posicio;
	}


	public int compareTo(DadesAlumne dades) {
		if (getNota()<dades.getNota())
			return 1;
		else if (getNota()>dades.getNota())
			return -1;
		return 0;
	}


	public String toString() {
		return "["+getNom()+","+getNota()+"]";
	}



}
