package uoc.ei.exercicis.modul9.exercici1;

import uoc.ei.tads.*;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ExpedientImpl implements Expedient, ObservadorContenidorPosicional<DadesAlumne> {

	private Diccionari<String,DadesAlumne> alumnes;
	private CuaAmbPrioritatActualitzable<DadesAlumne> rankingAlumnes;


	public ExpedientImpl() {
		alumnes=new DiccionariAVLImpl<String,DadesAlumne>();
		rankingAlumnes=new CuaAmbPrioritatActualitzable<DadesAlumne>();
		rankingAlumnes.afegirObservador(this);
	}


	public void novaNota(String alumne,double credits,double nota) {
		DadesAlumne dadesAlumne=alumnes.consultar(alumne);
		if (dadesAlumne==null) {
			dadesAlumne=new DadesAlumne(alumne);
			alumnes.afegir(alumne,dadesAlumne);
			rankingAlumnes.encuar(dadesAlumne);
		}
		dadesAlumne.novaNota(credits,nota);
		rankingAlumnes.actualitzarPosicio(dadesAlumne.getPosicioHeap());
	}


	public double notaMitja(String alumne) {
		DadesAlumne dadesAlumne=alumnes.consultar(alumne);
		return dadesAlumne.getNota();
	}


	public String alumneAmbMillorExpedient() {
		return rankingAlumnes.primer().getNom();
	}


	public void notificarPosicioCreada(Posicio<DadesAlumne> posicio) {
		posicio.getElem().setPosicioHeap(posicio);
	}


	public void notificarPosicioEsborrada(Posicio<DadesAlumne> posicio) {
	}

}
