package uoc.ei.tads;
/**
 * Seqncia que es caracteritza perqu es consulta i s'esborra el primer
 * element inserit: first-in-first-out (FIFO).
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface Cua<E>  extends Contenidor<E>
{
   /**
    * Afegeix un element a la cua, si hi cap.
    * @param elem  element que es vol afegir a la cua
    */
   public void encuar(E elem);

   /**
    * Esborra el primer element de la cua, si n'hi ha algun.
    * @exception ExcepcioContenidorBuit  si la cua est buida
    * @return  primer element inserit a la cua
    */
   public E desencuar();

   /**
    * Accessor de lectura del primer element afegit a la cua, si n'hi ha.
    * @exception ExcepcioContenidorBuit  si la cua est buida
    * @return  primer element de la cua
    */
   public E primer();
}
