package uoc.ei.tads;
/**
 * Classe que implementa l'excepci que es genera quan el constructor o
 * qualsevol mtode d'una classe rep un parmetre incorrecte que no
 * estigui contemplat en altres excepcions.
 *
 * s una extensi de les excepcions en temps d'execuci gestionades pel
 * propi compilador.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ExcepcioParametreIncorrecte  extends ExcepcioTADs
{
   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();
	
	
   /** Constructor sense parmetres. */
   public ExcepcioParametreIncorrecte() { super(); }

   /**
    * Constructor amb un parmetre.
    * @param missatge  missatge amb l'error que ha generat l'excepci
    */
   public ExcepcioParametreIncorrecte(String missatge)
   {
      super(missatge);
   }
}
