package uoc.ei.tads;
/**
 * Classe que implementa les excepcions que es poden produir generalment
 * per errors de programaci a la llibreria de TADs, els quals s'haurien
 * evitat fent correctament les comprovacions oportunes.
 *
 * s una extensi de les excepcions en temps d'execuci gestionades pel
 * propi compilador.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class ExcepcioTADs  extends RuntimeException
{
   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();
	
	
   /** Constructor sense parmetres. */
   public ExcepcioTADs() { super(); }

   /**
    * Constructor amb un parmetre.
    * @param missatge  missatge amb l'error que ha generat l'excepci
    */
   public ExcepcioTADs(String missatge) { super(missatge); }
}
