package uoc.ei.tads;
/**
 * Interfcie que defineix les operacions de recorregut bidireccional dels
 * elements d'un contenidor.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface IteradorBidireccional<E>  extends Iterador<E>
{

	/**
    * Comprova si hi ha un darrer o anterior element.
    */
   public boolean hiHaAnterior();

   /**
    * Accessor de lectura del darrer o anterior element de l'enumeraci.
    * @exception ExcepcioPosicioInvalida  si es vol obtenir l'anterior
    *            element de l'enumeraci i no n'hi ha cap o no n'hi ha cap
    *            ms
    * @return  darrer o anterior element a l'actual
    */
   public E anterior()  throws  ExcepcioPosicioInvalida;
 }
