
package uoc.ei.tads;

/** Implementaci d'iterador que permet iterar fent servir com a base
 * els elements d'un d'una seqncia d'iteradors.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class IteradorMultiple<E> implements Iterador<E> {
	
	LlistaEncadenada<Iterador<E>> iteradors;
	Iterador<Iterador<E>> iteradorDIteradors;
	Iterador<E> iteradorActual;
	
	
	public IteradorMultiple() {
		iteradors=new LlistaEncadenada<Iterador<E>>();
		iteradorDIteradors=null;
	}
	
	
	public void afegirIterador(Iterador<E> iterador) {
		iteradors.afegirAlFinal(iterador);
	}
	
	
	protected void inicialitzar() {
		iteradorDIteradors=iteradors.elements();
		seguentIterador();
	}
	

	protected void seguentIterador() {
		boolean trobat=false;
		while (!trobat && iteradorDIteradors.hiHaSeguent()) {
			iteradorActual=iteradorDIteradors.seguent();
			trobat=iteradorActual.hiHaSeguent();
		}
		if (!trobat)
			iteradorActual=null;
	}

	
	public boolean hiHaSeguent() {
		if (iteradorDIteradors==null)
			inicialitzar();
		return iteradorActual!=null;
	}


	public E seguent() throws ExcepcioPosicioInvalida {
		if (iteradorDIteradors==null)
			inicialitzar();
		E element=iteradorActual.seguent();
		if (!iteradorActual.hiHaSeguent())
			seguentIterador();
		return element;
	}

}
