package uoc.ei.tads;
/**
 * Classe que implementa les operacions de recorregut de les claus dels
 * elements d'un contenidor, per delegaci en un recorregut de posicions.
 *
 * @see  ClauValor
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class IteradorRecorregutClausImpl<C,E>  extends IteradorRecorregutImpl<C,ClauValor<C,E>>
{
   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();
	
	
   /**
    * Constructor amb un parmetre.
    * @param recorregut  recorregut que proporciona els elements
    */
   public IteradorRecorregutClausImpl(Recorregut<ClauValor<C,E>> recorregut)
   {
      super(recorregut);
   }

   /**
    * Accessor de lectura de l'element emmagatzemat a la posici.
    * @see  IteradorRecorregutImpl#seguent()    
    * @param pos  posici que cont l'element
    * @return  element contingut a la posici
    */
   protected C getElem(Posicio<ClauValor<C,E>> pos)
   {
      return  pos.getElem().getClau();
   }
}
