
package uoc.ei.tads;

/** Implementaci d'iterador per a recorrer els elements d'una
 * col.lecci que usa com a representaci un vector.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class IteradorVectorImpl<E> implements Iterador<E> {

   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();


	private E[] elements;
	private int nombreElements;
	private int index;

	public IteradorVectorImpl(E[] elements,int nombreElements,int primer) {
		this.elements=elements;
		this.nombreElements=nombreElements;
		index=primer;
	}

	public boolean hiHaSeguent() {
		return nombreElements>0;
	}

	public E seguent() {
		E element=elements[index];
		index++;
		if (index==elements.length) index=0;		// serveix per a representacions circulars
		nombreElements--;
		return element;
	}

}
