package uoc.ei.tads;
/**
 * Seqncia que es caracteritza perqu es consulta i s'esborra el darrer
 * element inserit: last-in-first-out (LIFO).
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface Pila<E>  extends Contenidor<E>
{
   /**
    * Afegeix un element a la pila, si hi cap.
    * @param elem  element que es vol afegir a la pila
    */
   public void empilar(E elem);

   /**
    * Esborra l'element del cim de la pila, si n'hi ha algun.
    * @exception ExcepcioContenidorBuit  si la pila est buida
    * @return  element que hi havia al cim de la pila
    */
   public E desempilar();

   /**
    * Accessor de lectura del darrer element afegit a la pila, si n'hi ha.
    * @exception ExcepcioContenidorBuit  si la pila est buida
    * @return  element del cim de la pila
    */
   public E cim();
}
