package uoc.ei.tads;

import java.io.Serializable;

/**
 * Interfcie que representa una posici d'un contenidor. Una posici s
 * el lloc que ocupa un element del contenidor i es defineix relativament,
 * per exemple, en relaci amb els seus vens.
 * 
 * Les classes que l'implementin han de concretar l'esmentada posici
 * associant-li un node encadenat, l'ndex d'un vector, etc.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface Posicio<E> extends Serializable
{
   /**
    * Accessor de lectura de l'element emmagatzemat a la posici.
    * @return  element emmagatzemat a la posici
    */
   public E getElem();

   /**
    * Accessor de lectura de la instncia del contenidor a la qual pertany
    * la posici.
    * @return  instncia del contenidor a la qual pertany la posici
    */
   // public Contenidor contenidor();
}
