package uoc.ei.tads;

import java.io.Serializable;

/**
 * Interfcie que defineix les operacions de recorregut de les posicions
 * d'un contenidor.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface Recorregut<E> extends Serializable
{
	   /**
	    * Comprova si hi ha un primer o segent element.
	    */
	   public boolean hiHaSeguent();

	   /**
	    * Accessor de lectura del primer o segent element de l'enumeraci.
	    * @exception ExcepcioPosicioInvalida  si es vol obtenir el segent
	    *            element de l'enumeraci i no n'hi ha cap o no n'hi ha cap
	    *            ms
	    * @return  primer o segent element a l'actual
	    */
	   public Posicio<E> seguent()  throws  ExcepcioPosicioInvalida;

}
