package uoc.ei.tads;
/**
 * Interfcie que defineix les operacions de recorregut de les posicions
 * d'un contenidor en amdues direccions.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface RecorregutBidireccional<E>  extends Recorregut<E> {

		/** Enumeraci que ens serveix per indicar per on comena el recorregut:
		 * si pel principi o pel final de la col.lecci.
		 */
		public enum IniciRecorregut { PRINCIPI, FINAL };
	
	   /**
	    * Comprova si hi ha un primer o segent element.
	    */
	   public boolean hiHaAnterior();

	   /**
	    * Accessor de lectura del anterior element de l'enumeraci.
	    * @exception ExcepcioPosicioInvalida  si es vol obtenir el segent
	    *            element de l'enumeraci i no n'hi ha cap o no n'hi ha cap
	    *            ms
	    * @return  primer o segent element a l'actual
	    */
	   public Posicio<E> anterior()  throws  ExcepcioPosicioInvalida;

}
