package uoc.ei.tads.algorismes;

import uoc.ei.tads.CuaAmbPrioritat;


/** Algorisme de HeapSort. Usa una cua amb prioritat per
 * ordenar una seqncia d'elements.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class HeapSort<E> implements AlgorismeOrdenacio<E> {

	public void ordenar(E[] vector,int n) {
		CuaAmbPrioritat<E> c=new CuaAmbPrioritat<E>(vector.length);
		for(int i=0;i<n;i++)
			c.encuar(vector[i]);
		for(int i=0;i<n;i++)
			vector[i]=c.desencuar();
	}

}
