package uoc.ei.tads.algorismes;

import uoc.ei.tads.CuaAmbPrioritat;


/** Algorisme de MergeSort. Usa la tcnica de divideix i vncer,
 * dividint el vector a ordenar en dues parts a les que se'ls
 * hi aplica l'algorisme recursivament per a desprs fusionar
 * les dues parts. El cas base consisteix en fusionar dues
 * seqncies d'un element cadascuna.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

public class MergeSort<E> implements AlgorismeOrdenacio<E> {

	public void ordenar(E[] vector,int n) {
		E[] vectorAuxiliar=(E[])new Object[n];
		mergeSort(vector,vectorAuxiliar,0,n-1);
	}


	private void mergeSort(E[] vector,E[] vectorAuxiliar,int inici,int fi) {
		int mig=(fi+inici)/2;
		if (inici<fi) {
			mergeSort(vector,vectorAuxiliar,inici,mig);
			mergeSort(vector,vectorAuxiliar,mig+1,fi);
			fusionar(vector,vectorAuxiliar,inici,mig,mig+1,fi);
		}
	}


	private void fusionar(E[] vector,E[] vectorAuxiliar,int ini1,int fi1,int ini2, int fi2) {
		int i1=ini1;
		int i2=ini2;
		int k=ini1;
		while (k<=fi2) {
			if (i2>fi2 || i1<=fi1 && comparar(vector,i1,i2)<=0) {
				vectorAuxiliar[k]=vector[i1];
				i1++;
			}
			else {
				vectorAuxiliar[k]=vector[i2];
				i2++;
			}
			k++;
		}
		for(int i=ini1;i<=fi2;i++)
			vector[i]=vectorAuxiliar[i];
	}


	private int comparar(E[] vector,int i,int j) {
		return ((Comparable<E>)vector[i]).compareTo(vector[j]);
	}


}
