package uoc.ei.tads.grafs;

import java.io.Serializable;

/**
 * Arista.java
 * Arista de un grafo (dirigido o no dirigido).
 *
 * @author  Jordi Àlvarez Canal
 * @author  Esteve Mariné Gallisà.
 *          Estructura de la Informació,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface Aresta<TEtiqueta,TElem> extends Serializable {

  /**
   * Obtiene el valor asociado a la arista.
   * @return null si el grafo es no valorado.
   */
   public TEtiqueta getEtiqueta();

   /**
   * Establece el valor asociado a la arista.
   * @pre true
   * @post obtenerValor()@pre == v
   */
  public void setEtiqueta(TEtiqueta v);

  /**
   * Indica si la arista incide en el vértice v.
   * @pre v!=null
   * @post true
   */
  public boolean incideixEnVertex(Vertex<TElem> v);

}
