package uoc.ei.tads.grafs;

import uoc.ei.tads.ExcepcioParametreIncorrecte;
import uoc.ei.tads.Utilitats;

/**
 * Classe que representa una aresta d'un graf dirigit. La relaci s entre
 * dos vrtexs del mateix domini i va del vrtex origen al de dest.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
class ArestaNDImpl<TEtiqueta,TElem>  extends ArestaImpl<TEtiqueta,TElem>
									implements ArestaNoDirigida<TEtiqueta,TElem>
{
   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();


   /** Constructor amb dos parmetres.
    * @param v1 vrtex A de l'aresta
    * @param v2 vrtex B de l'aresta
    * @exception ExcepcioParametreIncorrecte  si algun vrtex s null
    * @pre v1!=null && v2!=null, ExcepcioParametreIncorrecte
    */
   public ArestaNDImpl(VertexNDImpl<TElem,TEtiqueta> v1, VertexNDImpl<TElem,TEtiqueta> v2) {
      super(v1,v2);
   }

   public Vertex<TElem> getVertex1() { return  vertexA; }
   public Vertex<TElem> getVertex2() { return  vertexB; }


}