package uoc.ei.tads.grafs;

/**
 * Grafo.java
 * Grafo  no dirigido.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public interface GrafNoDirigit<TElem,TEtiqueta> extends Graf<TElem,TEtiqueta> {

   /**
   * Crea e incluye una nueva arista en el grafo.
   * @pre n!=null && m!=null && n!=m
   * @post (@return.obtenerVertice1()==n &&  @return.obtenerVertice2()==m) ||
           (@return.obtenerVertice1()==m &&  @return.obtenerVertice2()==n)
   */
  public ArestaNoDirigida<TEtiqueta,TElem> crearAresta(Vertex<TElem> n, Vertex<TElem> m);

   /**
   * Obtiene la arista que conecta dos vertices dados.
   * @pre n!=null & m!=null & n!=m
   * @post (@return.obtenerVertice1()==n &&  @return.obtenerVertice2()==m) ||
           (@return.obtenerVertice1()==m &&  @return.obtenerVertice2()==n)
   */
  public ArestaNoDirigida<TEtiqueta,TElem> obtenirAresta(Vertex<TElem> n, Vertex<TElem> m);

}
