
package uoc.ei.tads.grafs;

import uoc.ei.tads.Iterador;
import uoc.ei.tads.Utilitats;

/** Implementaci d'un graf no dirigit mitjanant llistes d'adjacncia.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class GrafNoDirigitImpl<TElem,TEtiqueta> extends GrafAbstracte<TElem,TEtiqueta>
												implements GrafNoDirigit<TElem,TEtiqueta> {


   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();


	public GrafNoDirigitImpl() {
		super();
	}


	protected VertexImpl<TElem, TEtiqueta> nouVertex(TElem valor) {
		return new VertexNDImpl<TElem,TEtiqueta>(valor);
	}


	public ArestaNoDirigida<TEtiqueta, TElem> crearAresta(Vertex<TElem> vertex1,
			Vertex<TElem> vertex2) {
		VertexNDImpl<TElem,TEtiqueta> v1=(VertexNDImpl<TElem,TEtiqueta>)vertex1;
		VertexNDImpl<TElem,TEtiqueta> v2=(VertexNDImpl<TElem,TEtiqueta>)vertex2;
		ArestaNDImpl<TEtiqueta,TElem> aresta=new ArestaNDImpl<TEtiqueta,TElem>(v1,v2);
		aresta.afegirAlGraf(this);
		return aresta;
	}


	public ArestaNoDirigida<TEtiqueta, TElem> obtenirAresta(Vertex<TElem> vertex1,
			Vertex<TElem> vertex2) {
		ArestaNoDirigida<TEtiqueta, TElem> resultat=null;
		VertexNDImpl<TElem,TEtiqueta> v1=(VertexNDImpl<TElem,TEtiqueta>)vertex1;
		Iterador<Aresta<TEtiqueta, TElem>> arestes=v1.arestes();
		while (arestes.hiHaSeguent() && resultat==null) {
			ArestaImpl<TEtiqueta, TElem> aresta=(ArestaImpl<TEtiqueta, TElem>)arestes.seguent();
			if (aresta.incideixEnVertexs(vertex1,vertex2))
				resultat=(ArestaNoDirigida<TEtiqueta,TElem>)aresta;
		}
		return resultat;
	}

}
