package uoc.ei.tads.grafs;

import uoc.ei.tads.Iterador;
import uoc.ei.tads.LlistaDoblementEncadenada;
import uoc.ei.tads.Posicio;
import uoc.ei.tads.Utilitats;

/** Classe que implementa un vrtex per al cas dels Grafs Dirigits.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */

class VertexNDImpl<TElem,TEtiqueta> extends VertexImpl<TElem,TEtiqueta> {

   /** Atribut que en Java 1.5 determina la compatibilitat entre objectes
    * serialitzables de la mateixa classe. L'deitificador es calcula
    * mitjanant un mtode de la classe Utilitats. */
   private static final long serialVersionUID = Utilitats.getSerialVersionUID();


   protected LlistaDoblementEncadenada<Aresta<TEtiqueta,TElem>> arestes;


   public VertexNDImpl(TElem element) {
   	  super(element);
   	  arestes=new LlistaDoblementEncadenada<Aresta<TEtiqueta,TElem>>();
   }


   public void afegirAresta(Aresta<TEtiqueta,TElem> aresta) {
   	  Posicio<Aresta<TEtiqueta,TElem>> posicio=arestes.afegirAlFinal(aresta);
   	  ArestaImpl<TEtiqueta,TElem> arestaI=(ArestaImpl<TEtiqueta,TElem>)aresta;
   	  if (this==arestaI.vertexA)
   	  	arestaI.setPosicioLlistaVertexA(posicio);
   	  else
   	  	arestaI.setPosicioLlistaVertexB(posicio);
   }


   public Iterador<Aresta<TEtiqueta,TElem>> arestes() {
   	  return arestes.elements();
   }


   public void eliminarAresta(ArestaImpl<TEtiqueta,TElem> aresta) {
   	  Posicio<Aresta<TEtiqueta,TElem>> posicio;
   	  ArestaImpl<TEtiqueta,TElem> arestaI=(ArestaImpl<TEtiqueta,TElem>)aresta;
   	  if (arestaI.vertexA==this)
   	  	  posicio=arestaI.posicioLlistaDeVertexA;
   	  else
   	  	  posicio=arestaI.posicioLlistaDeVertexB;
   	  arestes.esborrar(posicio);
   }


   /*public String toString() {
		String str=super.toString()+"\n";
		str+="  arestes: "+arestes+"\n";
		return str;
   }*/

}
