package uoc.ei.tads.tests;

import java.util.ArrayList;
import java.util.Random;

import uoc.ei.tads.Contenidor;
import uoc.ei.tads.Iterador;
import uoc.ei.tads.Recorregut;
import junit.framework.TestCase;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public abstract class TestContenidor extends TestCase {


	private static Random randomGenerator = new Random();

	// per a aquells tests que fan tests aleatoris
	protected static final int NUM_TESTS_ALEATORIS = 1;
	protected static final int NUM_ELEMS_TEST_ALEATORI = 100;
	public static final int REPETICIONS_MOLTES_OPS = 1000;
	// Noms per als diccionaris que fan servir representacions en vector
	public static final int MIDA_MOLTES_OPS = 1000;
	public static final int MIDA_PLENA = 3;


	public TestContenidor(String name) { super(name); }


    public TestContenidor() { super(); }


	protected void afegir(Contenidor<Integer> c,int elem) {}
	protected boolean esborrar(Contenidor<Integer> c,int elem) { return false; }
	protected Contenidor<Integer> crearContenidor() { return null; }
	protected Contenidor<Integer> crearContenidor(int numElems) { return null; }


	protected boolean estaOrdenat(Iterador<Integer> elems) {
		   boolean trobat=false;
		   int anterior=Integer.MIN_VALUE;
		   while (elems.hiHaSeguent() && !trobat) {
			   int elem=elems.seguent();
			   trobat=anterior>elem;
			   anterior=elem;
		   }
		   return !trobat;
	   }


	protected ArrayList<Integer> popularAleatoriament(Contenidor<Integer> contenidor,int numElems,int rangMaxElem) {
		ArrayList<Integer> elements=new ArrayList<Integer>();
		for (int i=0;i<numElems;i++) {
			int element=randomGenerator.nextInt(rangMaxElem);
			elements.add(element);
			afegir(contenidor,element);
		}
		return elements;
	}


	protected int esborrarElement(Contenidor<Integer> contenidor,ArrayList<Integer> elements) {
		int posicio=randomGenerator.nextInt(elements.size());
		int element=elements.remove(posicio);
		assertTrue(esborrar(contenidor,element));
		return element;
	}


	protected int comptarElems(Recorregut r) {
		int n=0;
		while (r.hiHaSeguent()) {
			r.seguent();
			n++;
		}
		return n;
	}


	protected int comptarElems(Iterador i) {
		int n=0;
		while (i.hiHaSeguent()) {
			i.seguent();
			n++;
		}
		return n;
	}


	protected void checkRecorregut(Recorregut<Integer> r, int[] elems) {
		int i=0;
		while (i<elems.length)
			assertEquals(elems[i++],(int)r.seguent().getElem());
	}


	protected void checkIterador(Iterador<Integer> r, int[] elems) {
		int i=0;
		while (i<elems.length)
			assertEquals(elems[i++],(int)r.seguent());
	}


}
