package uoc.ei.tads.tests;

import uoc.ei.tads.grafs.Aresta;
import uoc.ei.tads.grafs.Graf;
import uoc.ei.tads.grafs.GrafDirigit;
import uoc.ei.tads.grafs.GrafDirigitImpl;
import uoc.ei.tads.grafs.Vertex;

/**
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class TestGrafDirigit extends TestGraf {

	protected Graf<Character,Integer> crearGraf() {
		return new GrafDirigitImpl<Character,Integer>();
	}


	@Override
	protected Aresta<Integer, Character> crearAresta(
			Graf<Character, Integer> graf, Vertex<Character> v1,
			Vertex<Character> v2) {
		return ((GrafDirigit<Character,Integer>)graf).crearAresta(v1, v2);
	}


	@Override
	protected Aresta<Integer, Character> obtenirAresta(
			Graf<Character, Integer> graf, Vertex<Character> v1,
			Vertex<Character> v2) {
		return ((GrafDirigit<Character,Integer>)graf).obtenirAresta(v1, v2);
	}


	public void testCrearGrafABC() { super.testCrearGrafABC(); }
	public void testAdjacents() { super.testAdjacents(); }
	public void testVertexs() { super.testVertexs(); }
	public void testArestes() { super.testArestes(); }
	public void testObtenirAresta() { super.testObtenirAresta(); }
	public void testEliminarVertex() { super.testEliminarVertex(); }
	public void testEliminarAresta() { super.testEliminarAresta(); }


	public void testArestesAmbDestiA() {
		GrafDirigit<Character,Integer> graf=(GrafDirigit<Character,Integer>)construirGrafABC();
		Vertex<Character> va=graf.consultarVertex('A');
		Vertex<Character> vc=graf.consultarVertex('C');
		Vertex<Character> vg=graf.consultarVertex('G');
		Vertex<Character> vb=graf.consultarVertex('B');
		int[] etiquetesA={2, 10};
		checkArestes(graf.arestesAmbDestiA(va),etiquetesA);
		int[] etiquetesC={9, 5};
		checkArestes(graf.arestesAmbDestiA(vc),etiquetesC);
		int[] etiquetesG={};
		checkArestes(graf.arestesAmbDestiA(vg),etiquetesG);
		int[] etiquetesB={1};
		checkArestes(graf.arestesAmbDestiA(vb),etiquetesB);
	}


	public void testArestesAmbOrigenA() {
		GrafDirigit<Character,Integer> graf=(GrafDirigit<Character,Integer>)construirGrafABC();
		Vertex<Character> va=graf.consultarVertex('A');
		Vertex<Character> vc=graf.consultarVertex('C');
		Vertex<Character> vg=graf.consultarVertex('G');
		Vertex<Character> vb=graf.consultarVertex('B');
		int[] etiquetesA={5, 5, 4};
		checkArestes(graf.arestesAmbOrigenA(va),etiquetesA);
		int[] etiquetesC={};
		checkArestes(graf.arestesAmbOrigenA(vc),etiquetesC);
		int[] etiquetesG={9, 1};
		checkArestes(graf.arestesAmbOrigenA(vg),etiquetesG);
		int[] etiquetesB={2, 7};
		checkArestes(graf.arestesAmbOrigenA(vb),etiquetesB);
	}


}
