package uoc.ei.tads.tests;
import junit.framework.Test;
import junit.framework.TestSuite;
/**
 * Srie de tests.
 *
 * @author  Jordi lvarez Canal
 * @author  Esteve Marin Gallis.
 *          Estructura de la Informaci,
 *          Universitat Oberta de Catalunya (UOC)
 * @version  2.0.0
 * @since  1.5
 */
public class TestSuiteLlibreriaTADs extends TestSuite
{

	/** Defineix tota la srie de test cases. */
   public static Test suite()
   {
      TestSuite suite = new TestSuite();
      suite.addTest(new TestSuite(TestPilaVectorImpl.class));
      suite.addTest(new TestSuite(TestCuaVectorImpl.class));
      suite.addTest(new TestSuite(TestLlistaEncadenada.class));
      suite.addTest(new TestSuite(TestLlistaDoblementEncadenada.class));
      suite.addTest(new TestSuite(TestCuaAmbPrioritat.class));
      suite.addTest(new TestSuite(TestDiccionariDispersio.class));
      suite.addTest(new TestSuite(TestDiccionariAVL.class));
      suite.addTest(new TestSuite(TestDiccionariLlista.class));
      suite.addTest(new TestSuite(TestDiccionariVector.class));
      suite.addTest(new TestSuite(TestConjuntDispersio.class));
      suite.addTest(new TestSuite(TestConjuntAVL.class));
      suite.addTest(new TestSuite(TestArbreBinariEncadenatImpl.class));
      suite.addTest(new TestSuite(TestArbreBinariVectorImpl.class));
      suite.addTest(new TestSuite(TestArbreGeneralDelegImpl.class));
      suite.addTest(new TestSuite(TestGrafDirigit.class));
      suite.addTest(new TestSuite(TestGrafNoDirigit.class));
      return suite;
   }

   /** Permet fer el test. */
   public static void main(String[] args) 
   {
      junit.textui.TestRunner.run(suite());
   }
}
